"""
/***************************************************************************
 PostgisBBox
                                 A QGIS plugin
 Load a BBO from postgis layers
                              -------------------
        begin                : 2011-10-02
        copyright            : (C) 2011 by Francesco Boccacci
        email                : francescoboccacci@libero.it
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
"""
# Import the PyQt and QGIS libraries
from PyQt4.QtCore import *
from PyQt4.QtGui import *
from qgis.core import *
from qgis.gui import *
from qgis.utils import *
from mymap import MyWnd
from qgis.gui import *
from PyQt4.QtGui import QAction, QMainWindow
from PyQt4.QtCore import SIGNAL, Qt, QString
from qgis.core import *
import os, sys, math



# Initialize Qt resources from file resources.py
import resources
# Import the code for the dialog
from postgisbboxdialog import PostgisBBoxDialog
import postgis_utils
from ui_postgisbbox import Ui_PostgisBBox


class PostgisBBox (QDialog, Ui_PostgisBBox):

    def __init__(self, iface):
        
        QDialog.__init__(self)
        #QMessageBox.information( self.iface.mainWindow(),"Info", "Main" ) 
        # Set up the user interface from Designer.
        self.ui = Ui_PostgisBBox()
        self.ui.setupUi(self)
        QObject.connect(self.ui.ConnectToPostgis, SIGNAL("clicked()"), self.salutare)
        #database = self.listDatabases()
        #datbasestring=''
        #for i in database:
                #QMessageBox.information( self.iface.mainWindow(),"Info", i )
                #databasestring +=i
        #        self.ui.ConnessioniPostgis.addItem(i)
        # Save reference to the QGIS interface
        self.iface = iface
        self.canvas = self.iface.mapCanvas() #CHANGE
        # this QGIS tool emits as QgsPoint after each click on the map canvas
        #self.clickTool = QgsMapToolEmitPoint(self.canvas)
        self.db = None
        #self.ConnessioniPostgis.clear()
        #self.database = self.listDatabases()
        #datbasestring=''
       
            #QMessageBox.information( self.iface.mainWindow(),"Info",collegamento)
        
        #QMessageBox.information( self.iface.mainWindow(),"Info", str(self.ConnessioniPostgis.count()))
        #QObject.connect(self.ConnessioniPostgis, SIGNAL("currentIndexChanged(QString)"), self.update)
        
        #QMessageBox.information( self.iface.mainWindow(),"Info", str(self.ConnessioniPostgis.count()))
    
        


    def initGui(self):
        # Create action that will start plugin configuration
        QDialog.__init__(self)
        #self.iface = iface
        self.setupUi(self)
        # Set up the user interface from Designer.
        #self.ui = Ui_PostgisBBox()
        #self.ui.setupUi(self)
        
        self.action = QAction(QIcon(":/plugins/PostgisBBox/postgis_select.png"), \
            "PostgisBBOX", self.iface.mainWindow())
        # connect the action to the run method
        QObject.connect(self.action, SIGNAL("triggered()"), self.run)
        #QObject.connect(self.ConnectToPostgis, SIGNAL("clicked()"), self.salutare)
        

        # Add toolbar button and menu item
        self.iface.addToolBarIcon(self.action)
        self.iface.addPluginToMenu("&PostgisBBOX", self.action)
        
        #self.statusBar = QStatusBar(self)
        #self.setStatusBar(self.statusBar)
        #result = QObject.connect(self.clickTool, SIGNAL("canvasClicked(const QgsPoint &, Qt::MouseButton)"), self.handleMouseDown)
        #QMessageBox.information( self.iface.mainWindow(),"Info", "connect = %s"%str(result) )
    def salutare(self):
        QMessageBox.information( self.iface.mainWindow(),"Info", "Cliccato" )
    
    def updateListDatabase(self):    
        database = self.listDatabases()
        #datbasestring=''
        for i in database:
                #QMessageBox.information( self.iface.mainWindow(),"Info", i )
                #databasestring +=i
                self.ConnessioniPostgis.addItem(i)
                #self.BBoxBottom.insert(i)
                #self.ConnessioniPostgis.insertItems(i)
                #self.listView.setText(i)
        #self.ConnessioniPostgis.view()
    #def handleMouseDown(self, point, button):
        #QMessageBox.information( self.iface.mainWindow(),"Info", "X,Y = %s,%s" % (str(point.x()),str(point.y())) )
#

    def unload(self):
        # Remove the plugin menu item and icon
        self.iface.removePluginMenu("&PostgisBBOX",self.action)
        self.iface.removeToolBarIcon(self.action)
    
    def listDatabases(self):
        
        #self.ui.setupUi(self)
        self.actionsDb = {}
        settings = QSettings()
        settings.beginGroup("/PostgreSQL/connections")
        keys = settings.childGroups()
        #QMessageBox.information( self.iface.mainWindow(),"Info", unicode(keys) ) 
        
        for key in keys:
            self.actionsDb[unicode(key)] = key
            
        settings.endGroup()
        
        return self.actionsDb

    def dbConnectInit(self, database):
        #QMessageBox.information( self.iface.mainWindow(),"Info", str(len(self.actionsDb)))
        #if len(self.actionsDb) == 0:
        #    QMessageBox.information(self, "No connections", "You apparently haven't defined any database connections yet.\nYou can do so in Quantum GIS by opening Add PostGIS layer dialog.\n\nWithout database connections you won't be able to use this plugin.")
        #    return

        settings = QSettings()
        #selected = unicode(settings.value("/PostgreSQL/connections/selected").toString())
        #self.dbConnect(selected)
        self.dbConnect(database)
        
        
    def dbConnect(self):
    #def dbConnect(self, database):
        
        #selected = "Local"
        #if index == -1:  
        selected = self.dlg.ui.ConnessioniPostgis.currentText()
        self.currentindex = self.dlg.ui.ConnessioniPostgis.currentIndex()
      
             
        
        
        settings = QSettings()
    
        # if there's open database already, get rid of it
        if self.db:
            self.dbDisconnect()
        
        # get connection details from QSettings
        settings.beginGroup( u"/PostgreSQL/connections/" + selected )
        if not settings.contains("database"): # non-existent entry?
            QMessageBox.critical(self, "Error", "Unable to connect: there is no defined database connection \"%s\"." % selected)
            return
        #else:
            #QMessageBox.information( self.iface.mainWindow(),"Prima", "Databse conesso a " + selected)
        get_value_str = lambda x: unicode(settings.value(x).toString())
        self.host, self.database, self.username, self.password = map(get_value_str, ["host", "database", "username", "password"])
        self.port = settings.value("port").toInt()[0]
        
        # qgis1.5 use 'savePassword' instead of 'save' setting
        if not ( settings.value("save").toBool() or settings.value("savePassword").toBool() ):
            (password, ok) = QInputDialog.getText(self, "Enter password", "Enter password for connection \"%s\":" % selected, QLineEdit.Password)
            if not ok: return
        settings.endGroup()
        
        #self.statusBar.showMessage("Connecting to database (%s) ..." % selected)
        QApplication.processEvents() # give the user chance to see the message :)
        
        # connect to DB
        try:
            self.db = postgis_utils.GeoDB(host=self.host, port=self.port, dbname=self.database, user=self.username, passwd=self.password)
            #QMessageBox.information( self.iface.mainWindow(),"Prima", "Databse conesso a " + selected)
            self.tables = self.db.list_geotables()
            n_tables = len(self.tables)
            t_n = 0
            #QMessageBox.information( self.iface.mainWindow(),"Prima", "Tabella " + str(n_tables))
            for t in self.tables :
                 if str(t[7]) != "None" :        
                        t_n+=1
            n_tables = t_n
            self.dlg.ui.tableWidget.setRowCount(n_tables)
            #QMessageBox.information( self.iface.mainWindow(),"Prima", "Tabella " + str(n_tables))
            i = 0
            for t in self.tables :
                
                #self.geo = t.check_geometry_columns_table()
                if str(t[7]) != "None" :
                        #self.tableWidget.insertRow(i)
                        tab = QTableWidgetItem(str(t[0]))
                        #type = QTableWidgetItem(str(t[7]))
                        self.dlg.ui.tableWidget.setItem(i,0,tab)
                        #self.dlg.ui.tableWidget.setItem(i,1,type)
                        
                        #self.dlg.ui.listTable.addItem(str(t[0]) + "  " + str(t[7]))
                        i+=1
            
            
                        #QMessageBox.information( self.iface.mainWindow(),"Prima", "Tabella " + str(t[7]))
            #QMessageBox.information( self.iface.mainWindow(),"Prima", "Tabella " + str(self.ui.tableWidget.rowCount()))             
        except postgis_utils.DbError, e:
            #self.statusBar.clearMessage()
            QMessageBox.critical(self, "error", "Couldn't connect to database:\n"+e.msg)
            return
        self.writeLastConnection(selected)
       
    def dbDisconnect(self):
        
        # uncheck previously selected DB
        """
        for a in self.actionsDb.itervalues():
            if a.isChecked():
                a.setChecked(False)
        
        self.db = None
        self.txtMetadata.setDatabase(None)
        self.refreshTable()
        
        self.actionDbDisconnect.setEnabled(False)
        """
        #self.enableGui(False)
        
        #self.currentView = ManagerWindow.ViewNothing
        #self.updateView()

        #self.updateWindowTitle()
        
    def addLayers (self):
        
            
        
            selTable = self.dlg.ui.tableWidget.selectedItems()
        #QMessageBox.information( self.iface.mainWindow(),"Lunghezza", str(len(selTable)) )
            lt = len(selTable) 
        #QMessageBox.information( self.iface.mainWindow(),"Lunghezza", str(l) )
        
        
        
            i=0
            for l in selTable:  
                for t in self.tables:
                    if str(t[0]) == selTable[i].text():   
                        uri = QgsDataSourceURI()
                        
                #uri.setConnection("localhost", "5432", "test_postgis", "postgres", "postgres")
                        uri.setConnection(str(self.host), str(self.port), str(self.database), str(self.username), str(self.password))
                        #QMessageBox.information( self.iface.mainWindow(),"Lunghezza", "Prima" )
                        uri.setDataSource("public",  selTable[i].text(), str(t[6]))
                        layer = QgsVectorLayer(uri.uri(), selTable[i].text(), "postgres")
                        
                        #QMessageBox.information( self.iface.mainWindow(),"Mappa", str(self.epgslayermap) )
                        #QMessageBox.information( self.iface.mainWindow(),"Tabella", str(layer.crs().epsg() ))
        
                        crsStart = QgsCoordinateReferenceSystem()
                        crsStart.createFromProj4(self.proj4layermap)
                        crsDest = QgsCoordinateReferenceSystem()  
                        crsDest.createFromProj4(layer.crs().toProj4())
                        #if self.epgslayermap != layer.crs().epsg():
                        if crsStart != crsDest:
                            
                            #QMessageBox.information( self.iface.mainWindow(),"Mappa", str(self.w.xmin()) )
                            uri.setDataSource("public",  selTable[i].text(), str(t[6]))
                        
                            bbox = QgsRectangle()
                            bbox.setXMinimum(self.w.xmin())
                            bbox.setXMaximum(self.w.xmax())
                            bbox.setYMinimum(self.w.ymin())
                            bbox.setYMaximum(self.w.ymax())
                            
                            
                            bboxNew = QgsCoordinateTransform(crsStart,crsDest).transformBoundingBox(bbox)
                            #QMessageBox.information( self.iface.mainWindow(),"Tabella", str(bboxNew.xMinimum()) )
                            #QMessageBox.information( self.iface.mainWindow(),"Mappa", str(bboxNew.xMinimum()) )
        
                            #sql = "the_geom && setsrid('BOX3D(" + left+ " " + bottom + " , " + right + " " + top + ")'::box3d,-1)"
                            sql = str(t[6]) + " && setsrid('BOX3D(" + str(bboxNew.xMinimum()) + " " + str(bboxNew.yMinimum()) + " , " + str(bboxNew.xMaximum()) + " " + str(bboxNew.yMaximum()) + ")'::box3d, " + str(layer.crs().epsg()) + ")"
                        
                            uri.setDataSource("public",  selTable[i].text(), str(t[6]), sql)
                            #QMessageBox.information( self.iface.mainWindow(),"Mappa", "Diversi3" )
                            #QMessageBox.information( self.iface.mainWindow(),"Mappa", str(uri.uri()) )
                            self.iface.addVectorLayer(uri.uri(), selTable[i].text(), "postgres")
                            #QMessageBox.information( self.iface.mainWindow(),"Mappa", "Diversi5" )
                            
                        else:
                            
                            #QMessageBox.information( self.iface.mainWindow(),"Mappa", "Uguali" )
                            uri.setDataSource("public",  selTable[i].text(), str(t[6]))
                                                     
        
                            #sql = "the_geom && setsrid('BOX3D(" + left+ " " + bottom + " , " + right + " " + top + ")'::box3d,-1)"
                            sql = str(t[6]) + " && setsrid('BOX3D(" + str(self.w.xmin()) + " " + str(self.w.ymin()) + " , " + str(self.w.xmax()) + " " + str(self.w.ymax()) + ")'::box3d,-1)"
                        
                            uri.setDataSource("public",  selTable[i].text(), str(t[6]), sql)
                            self.iface.addVectorLayer(uri.uri(), selTable[i].text(), "postgres")
                           
                                
                i+=1 
                self.writeLastBBox(str(self.w.xmin()),str(self.w.ymin()), str(self.w.xmax()), str(self.w.ymax()))
                self.view = 1
      
    
        
    def showMap(self):
        
        


        
        
        
        if os.name == "nt": # Windows
                home = plugin_paths
                
                for h in home:
                    #self.layer = QgsVectorLayer(h +"/PostgisBBox/shape/world.shp", "pop2", "ogr")
                    self.layer = QgsRasterLayer(h + '/PostgisBBox/wms.xml','2007 Aerial')
                    if self.layer.isValid():
                        break 
        else: # Linux
           
            home = os.getenv("HOME")
            #self.layer = QgsVectorLayer(home+"/.qgis/python/plugins/PostgisBBox/shape/world.shp", "pop2", "ogr")
            self.layer = QgsRasterLayer(h + "/.qgis/python/plugins/PostgisBBoxwms.xml",'2007 Aerial')
        #self.epgslayermap = self.layer.crs().epsg()
        self.proj4layermap = self.layer.crs().toProj4()
        
        
        #QMessageBox.information( self.iface.mainWindow(),"Prima", self.readLastBBox() )
        
           
        
        if os.name == "nt": # Windows
                home = plugin_paths
                for h in home:
                    try:    
                        readBB = open(h + "/PostgisBBox/BBox.txt","r")
                        break
                    except:
                        pass
                    
        else: # Linux
            
                home = os.getenv("HOME")
                #out_file = os.open(home + "/.qgis/python/plugins/PostgisBBox/test.txt","w")
                readBB = open(home + "/.qgis/python/plugins/PostgisBBox/BBox.txt","r") 
                
                
        ex = QgsRectangle()
        ex.setXMinimum(float(readBB.readline()))
        ex.setYMinimum(float(readBB.readline()))
        ex.setXMaximum(float(readBB.readline()))
        ex.setYMaximum(float(readBB.readline()))
        readBB.close()
        
        self.w = MyWnd(self.layer,ex)
        
        self.w.show()
        
    def writeLastBBox(self,xmin,ymin,xmax,ymax):
        
        if os.name == "nt": # Windows
                home = plugin_paths
                
                for h in home:
                    try:
                        
                        self.writeBB = open(h + "/PostgisBBox/BBox.txt","w")
                        
                        self.writeBB.write(xmin + "\n" + ymin + "\n" + xmax + "\n" + ymax)
                
                        self.writeBB.close()
                        break
                    except:
                        pass
        else: # Linux
            
                home = os.getenv("HOME")
                
                
                self.writeBB = open(home + "/.qgis/python/plugins/PostgisBBox/BBox.txt","w") 
                self.writeBB.write(xmin + "\n" + ymin + "\n" + xmax + "\n" + ymax)
             
                self.writeBB.close()
                
    def writeLastConnection(self,LastConnection):
        
       
        
        if os.name == "nt": # Windows
                home = plugin_paths
                len(home)
                for h in home:
                    try:
                        
                        self.writeCon = open(h + "/PostgisBBox/Connection.txt","w")
                        
                        self.writeCon.write(LastConnection)
                
                        self.writeCon.close()
                        break
                    except:
                        pass
        else: # Linux
            
                home = os.getenv("HOME")
                
                
                self.writeCon = open(home + "/.qgis/python/plugins/PostgisBBox/Connection.txt","w") 
                self.writeCon.write(LastConnection)
             
                self.writeCon.close()            
        
    def ChangeExt(self):
        
        #QMessageBox.information( self.iface.mainWindow(),"Prima", "Cambiato")

            
    
        self.dlg.ui.BBoxTop.setText(str(self.w.ymax()))
        
        self.dlg.ui.BBoxBottom.setText(str(self.w.ymin()))
        
        self.dlg.ui.BBoxRight.setText(str(self.w.xmax()))
        
        self.dlg.ui.BBoxLeft.setText(str(self.w.xmin()))
    
    
    def outProjFile(self):
        
        format = QString( "<h2>%1</h2>%2 <br/> %3" )
        header = QString( "Define layer CRS:" )
        sentence1 = self.tr( "Please select the projection system that defines the current layer." )
        sentence2 = self.tr( "Layer CRS information will be updated to the selected CRS." )
        self.projSelect = QgsGenericProjectionSelector(self, Qt.Widget)
        self.projSelect.setMessage( format.arg( header ).arg( sentence1 ).arg( sentence2 ))
        if self.projSelect.exec_():
            self.projString = self.projSelect.selectedProj4String()
            self.epsgString = str(self.projSelect.selectedEpsg())
            
            if self.projString == "":
                QMessageBox.information(self, self.tr("Export to new projection"), self.tr("No Valid CRS selected"))
                return
            else:
                self.dlg.ui.txtProjection.clear()
                #self.dlg.ui.txtProjection.insert(self.projString)
                
                self.dlg.ui.txtProjection.insert("EPSG:" + self.epsgString)
                #QgsCoordinateTransform(projString,projString)
                #QgsCoordinateTransform.transformBoundingBox()
                #self.dlg.ui.txtProjection.setText(projString)
                
                #QMessageBox.information( self.iface.mainWindow(),"Prima", projString)
        else:
            return

        

    # run method that performs all the real work
    def run(self):

        #Check if psycopg2 python module is installed.This module is usefull 
        #to connect to Postgresql/Postgis database 
        try:
            import psycopg2
        except ImportError, e:
            QMessageBox.information(self.iface.mainWindow(), "hey", "Couldn't import Python module 'psycopg2' for communication with PostgreSQL database. Without it you won't be able to run PostGIS manager.")
            return
        #self.listDatabases()
        
        #self.dbConnectInit("Local")
        
        # create and show the dialog
        self.dlg = PostgisBBoxDialog()
        
        
        
        #QgsLegendInterface.setLayerVisible(layer, False)
        
        
        self.actionsDb = {}
        settings = QSettings()
        settings.beginGroup("/PostgreSQL/connections")
        keys = settings.childGroups()
        
        for key in keys:
            self.actionsDb[unicode(key)] = key
            self.dlg.ui.ConnessioniPostgis.addItem(key)
            
        settings.endGroup()
       
        #QObject.connect(self.dlg.ui.ConnectToPostgis, SIGNAL("clicked()"), self.salutare)
        QObject.connect(self.dlg.ui.ConnectToPostgis, SIGNAL("clicked()"), self.dbConnect)
        QObject.connect(self.dlg.ui.BBoxButton, SIGNAL("clicked()"), self.showMap)
        
        
        try :
            if self.view == 1:
                self.dlg.ui.ConnessioniPostgis.setCurrentIndex(self.currentindex)
                self.dbConnect()
        except:
            pass
        #QMessageBox.information( self.iface.mainWindow(),"Prima", str(self.ConnessioniPostgis.count()))
        #self.updateListDatabase()
        #QMessageBox.information( self.iface.mainWindow(),"Dopo", str(self.ConnessioniPostgis.count()))
        
                
                     
                
        self.dlg.show()
        result = self.dlg.exec_()
            
        
            # See if OK was pressed
        if result == 1:
                
                #self.ChangeExt()
                self.addLayers()
                # Scrive un file.
                
                try:
                    QgsMapLayerRegistry.instance().removeMapLayer(self.layer.getLayerID())
                except:
                    pass         
                try:
                    self.w.close()
                except:
                    pass
                self.run()   
        else:
            self.view = 0  
                
                
        
              
        
    
